#ifndef _ABSTRACT_FRACTAL_H_
#define _ABSTRACT_FRACTAL_H_

#include "abstract_palette.h"
#include <QtCore/QString>

class FractalPainter;

class AbstractFractal
{
  protected:
    QString _name;
    QString _description;
    AbstractPalette *_palette;
  public:
    AbstractFractal (AbstractPalette *palette)
    : _name("abstract fractal"), _description("abstract fractal"), _palette(palette)
    {
      
    }
    
    virtual ~AbstractFractal ()
    {
    }
    
    QString name () const
    {
      return _name;
    }
    
    QString description () const
    {
      return _description;
    }

    virtual void draw (FractalPainter *painter) const = 0;
};

#endif
