#ifndef _FRACTAL_PAINTER_H_
#define _FRACTAL_PAINTER_H_

#include <QtGui/QWidget>
#include <QtGui/QPaintEvent>
#include <QtGui/QImage>

class FractalPainter: public QWidget
{
  Q_OBJECT
  private:
    QImage *_canvas;
  public:
    FractalPainter (int width, int height, QWidget *parent = 0)
    :QWidget(parent)
    {
      _canvas = new QImage(width, height, QImage::Format_RGB888);
      setFixedWidth(width);
      setFixedHeight(height);
      setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
    }
    
    ~FractalPainter ()
    {
      delete _canvas;
    }
    
    const QImage* canvas () const
    {
      return _canvas;
    }

    QImage* canvas ()
    {
      return _canvas;
    }
    
  protected:
    void paintEvent(QPaintEvent *event);
};

#endif
